#include <stdio.h>


/* Return the length in bytes or 0 on failure */

long FileSize(const char *fname)
{
	int fildes;
	long size=0;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		size=lseek(fildes,0L,SEEK_END);
		close(fildes);
	}
	
	return size;
}


int Load(const char *fname, void *start, long size)
{
	int fildes,f=0;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		read(fildes,start,size);
		close(fildes);
	}
	else f=1;
	
	return f;
}


int Save(const char *fname,void *start,long size)
{
	int fildes,f=0;
	
	fildes=open(fname,O_WRONLY|O_CREAT|O_TRUNC);
	if (fildes>=0)
	{
		if (write(fildes,start,size)!=size)
			f=1;
		close(fildes);
	}
	else f=1;
	
	return f;
}