/* TIP version 0.1  1997.07.01
 * for PURE C
 */

#include <tos.h>
#include <stdio.h>
#include <stdlib.h>
#include "sizes.h"
#include "def.h"
#include "algo.h"
#include "fhnd.h"
#include "imgtypes.h"
#include "targa.h"


void main(int argc,const char *argv[])
{
	const char *fname;
	ubyte *icmap,cmap[COLOURS*3],name[128],name2[]="out.tga",ub,*ubp;
	half nbox,ncol,i,j;
	ufull size,*hist;
	void *mem;
	BOX b[COLOURS];
	IMAGE src,dst;
	
	
	printf("TIP version 0.1\n\n");
	
	if (argc>1)
		fname=argv[argc-1];
	else
	{
		printf("File name: ");
		fflush(stdin);
		scanf("%s",name);
		fname=name;
	}	
		
	size=FileSize(fname);
	if (size!=0L)
	{
		mem=malloc(size+HSIZE+ICMAP+COLOURS*3);
		if (mem!=NULL)
		{
			(ubyte *)src.header=(ubyte *)mem+COLOURS*3;
			Load(fname,src.header,size);
			
			if (TestType2(&src)==0)
			{
				printf("Colours: ");
				fflush(stdin);
				scanf("%d",&ncol);
				if (ncol<2 || ncol>256)
				{
					if (ncol<2) ncol=2;
					if (ncol>256) ncol=256;
					printf("Colours= %d\n",ncol);
				}
				
				(ubyte *)hist=(ubyte *)src.header+size;
				icmap=(ubyte *)hist+HSIZE;
				
				printf("Building histogram...\n");
				MakeHistogram(src.width*src.height,src.image,hist);
				
				/* Init first box */
				printf("Initialize first box...\n");
				ubp=(ubyte *)b;
				for (i=29;i>=0;i--)
					*ubp++=0;
				b[0].r2=63;
				b[0].g2=63;
				b[0].b2=63;
				nbox=1;
				
				printf(".shrinking box\n");
				ShrinkBox((COORD *)&b[0].r1,hist);
				
				printf(".gathering statistics\n");
				Sum((STAT *)b,(COORD *)&b[0].r1,hist);
				b[0].v=Variance((STAT *)b);
				
				printf("Splitting boxes...\n%3d",nbox);
				while (nbox<ncol)
				{
					if (SplitBox(b,nbox,hist))
						break;
					nbox++;
					printf("\r%3d",nbox);
				}
				printf(" boxes\n");
				
				(ubyte *)dst.header=src.image-nbox*3-18;
				dst.cmap=(ubyte *)dst.header+18;
				dst.image=src.image;
				dst.width=src.width;
				dst.height=src.height;
				dst.bpp=8;
				dst.ncol=nbox;
				
				printf("Building colourmap...\n");
				MakeColourMap(b,cmap,nbox);
				
				printf("Building inverse colourmap...\n");
				MakeICMap(b,cmap,icmap,hist,nbox);
				
				printf("Remapping picture...\n");
				RemapPicture(src.image,dst.image,icmap,src.width*src.height);
				
				printf("Converting to type 1 Targa picture format...\n");
				MakeType1Header(&dst);
				/* Copy colour map */
				ubp=dst.cmap;
				for (i=0;i<nbox;i++)
				{
					*ubp++=cmap[i*3+2];
					*ubp++=cmap[i*3+1];
					*ubp++=cmap[i*3+0];
				}
				
				j=0;
				for (i=0;i<128;i++)
				{
					name[i]=ub=fname[i];
					if (ub==0x2F || ub==0x5C)
						j=i+1;
					if (ub==0)
						break;
				}
				if (j>=(128-13))
					j=0;
				for (i=0;i<8;i++)
				{
					name[j]=name2[i];
					j++;
				}
				printf("Saving picture as %s...\n",name2);
				Save(name,dst.header,18+nbox*3+dst.width*dst.height);
			}
			free(mem);
		}
		else
		{
			printf("Not enought memory.");
			fflush(stdin);
			Crawcin();
		}
	}
	else
	{
		printf("File error.");
		fflush(stdin);
		Crawcin();
	}
}